/* $Id: AssortLayings.java,v 1.18 2014/03/05 05:45:27 mit Exp $ */
/* AssortLayings.java v0.1.1 */

public class AssortLayings {
    private final int KB = 88;
    private final int OCT = 12;
    private final int CENT = 1200;
    private final int OCTP = 13;
    private final int P5 = 7;
    private final int P4 = 5;
    private final int J3 = 4;
    private final int I3 = 3;
    private final int[][] keys = { // 
	{36,41,34,39,32,37,42,35,40,33,38,39}, // 0~87
	{36,43,38,33,40,35,42,37,32,39,34,37},//41}//
	{36,36,41,37,37,42,38,38,43,39,39,44},
	{36,40,40,33,37,41,34,38,42,35,39,39},
	{36,36,41,38,35,38,43,40,37,37,42,39},
	{36,39,42,35,38,41,41,34,37,40,40,39}};
    private final int[][] lays = { // (+-)
	{P4,-P5,P4,-P5,P4,P4,-P5,P4,-P5,P4,P4,P4},
	{P5,-P4,-P4,P5,-P4,P5,-P4,-P4,P5,-P4,P5,P5},//-P4}//
	{-J3,P4,-J3,-J3,P4,-J3,-J3,P4,-J3,-J3,P4,-J3},
	{J3,J3,-P5,J3,J3,-P5,J3,J3,-P5,J3,J3,-P5},
	{-I3,P4,-I3,-I3,-I3,P4,-I3,-I3,-I3,P4,-I3,P4},
	{I3,I3,-P5,I3,I3,I3,-P5,I3,I3,I3,-P5,-P5}};
    private final int[][] ratio = { // ѤƤ벻
	{P4,P5},{P5,P4},{J3,P4},{J3,P5},{I3,P4},{I3,P5}};
    private final String[] layname = { // ȥ
	"P4-P5","P5-P4","mj3-P4","mj3-P5","mi3-P4","mi3-P5"};
    private final double REVOCT = 1.0/OCT;

    private boolean isCalc;
    private boolean EXTEsw; // TuneNonZero
    private boolean DEBUG = false;
    private int FROM_KEY = 33-1;  // f
    private int TO_KEY = 45-1;    // f
    private int LAYS;
    private int[] KEYS;
    private int[] LAYING;
    private int RATIO1;
    private int RATIO2;
    private double BEAT1 = 0.0;
    private double BEAT2 = 0.0;
    private double[] Cent;
    private double[] Inha;

    private TuningNonZero TN;

    public AssortLayings() {
	TN = new TuningNonZero();

	reset_cent();
    }
    public void setLayings(double[] inha) {
	Inha = inha;
	setLaying(0); // ǥե
    }
    public void is_calc() {
	if (!isCalc) {
	    reset_cent(); // cent-0
	    calc_laying();
	}
    }
    public double[] getCent() {
	return Cent;
    }
    public int get_from_key() {
	return FROM_KEY;
    }
    public int get_laying_size() {
	return ratio.length;
    }
    public String get_layings_name(int num) {
	return layname[num];
    }
    //
    public void tuneExtension() {
	EXTEsw = true;

	tuneExte();
    }
    public void tuneExte() {
	TN.Tuning(Inha, this.getCent());
    }
    public void resetCent() {
	TN.resetCent();
	reset_cent();
	calc_laying();

	EXTEsw = false;
    }
    public boolean isExte() {
	return EXTEsw;
    }
    //
    public void setBeat3(double be) { // extension
	TN.setBeat(be);

	if (EXTEsw)
	    tuneExte();
    }
    public void setBeat1(double be) {
	BEAT1 = be;

	isCalc = false;
	reset_cent();
	calc_laying();
	if (EXTEsw)
	    tuneExte();
    }
    public void setBeat2(double ra) {
	BEAT2 = ra;

	isCalc = false;
	reset_cent();
	calc_laying();
	if (EXTEsw)
	    tuneExte();
    }
    public double getBeat1() {
	return BEAT1;
    }
    public double getBeat2() {
	return BEAT2;
    }
    public void resetIsCalc() {
	isCalc = false;
	EXTEsw = false;
	reset_cent();
	calc_laying();
    }
    public void setLaying(int num) {
	LAYS = num;
	if (num < 0 || num > ratio.length)
	    LAYS = 0;

	LAYING = select_laying();
	KEYS = select_keys();
	int[] ra = select_ratio();
	RATIO1 = ra[0];
	RATIO2 = ra[1];
    }
    public int[] select_keys() {
	return keys[LAYS];
    }
    public int[] select_laying() {
	return lays[LAYS];
    }
    public int[] select_ratio() {
   	return ratio[LAYS];
    }
    public double centDiff() {
	double sm = 0;

	for (int i = FROM_KEY; i < TO_KEY; i++)
	    sm += Math.abs(Cent[i+1]-Cent[i]);

	return sm/OCTP;
    }
    public void calc_laying() {
	int key1, key0;
	double be;

	for (int i = 0; i < OCT; i++) {
	    key0 = KEYS[i];
	    key1 = key0+LAYING[i];
            be = (Math.abs(LAYING[i]) == RATIO1) ? BEAT1 : BEAT2;

	    tuneBeat(key0, key1, be);
        }

	isCalc = true;
    }
    public void tuneBeat(int key0, int key1, double beat) {
	double sa0 = 1.0;  // ®
	double sa1 = 0.02; // 
	double sa = sa1;
	double be0 = calcBeat(key0, key1);

	if (be0 < beat) {
	    while (be0 < beat) {
		sa = (Math.abs(be0-beat) > 1.0) ? sa0 : sa1;
		be0 = calc_beat(key0, key1, sa);
	    }
	} else {
	    while (be0 > beat) {
		sa = (Math.abs(be0-beat) > 1.0) ? -sa0 : -sa1;
		be0 = calc_beat(key0, key1, sa);
	    }
	}
    }
    public double calc_beat(int key0, int key1, double sa) {
	Cent[key1] += sa;

	return calcBeat(key0, key1);
    }
    public double calcBeat(int key0, int key1) {
        int mul = 6; // i36ޤɬ
        double[] f0 = calcPartial(mul, key0);
        double[] f1 = calcPartial(mul, key1);
        double[] be = new double[mul];

        double min = Double.MAX_VALUE;
        for (int i = 0; i < mul; i++) {
            for (int j = 0; j < mul; j++) {
                be[j] = f1[j]-f0[i];
                if (Math.abs(min) > Math.abs(be[j]))
                    min = be[j];
            }
        }

        return min;
    }
    public double[] calcPartial(int mul, int key) {
        double[] f = new double[mul];

        for (int i = 0; i < mul; i++) {
            f[i] = calciFreq(i+1, key);
        }

        return f;
    }
    public double calciFreq(int par, int key) {
        return ctof(getiFreq(key, par), getICent(key, par));
    }
    public double ctof(double f, double c) {
        return f*Math.pow(2, c/CENT);
    }
    public double getCent(int key) {
	return Cent[key];
    }
    public double getICent(int key, int par) {
	return calc_inha(key, par)+Cent[key];
    }
    public double getFreq(int key) {
        return 440*Math.pow(2, (key-48)*REVOCT); // 49-1
    }
    public void reset_cent() {
	Cent = new double[KB];

	for (int i = 0; i < KB; i++)
	    Cent[i] = 0;
    }
    public double calc_inha(int key, int par) {
	return Inha[key]*par*par;
    }
    public double getiFreq(int key, int par) {
	return getFreq(key)*par;
    }
    public double getiBeat(int key, int[] rat) {
	int keyh = key+rat[2];
	double fh = calciFreq(rat[1], keyh);
	double fl = calciFreq(rat[0], key);

	return (fh-fl);
    }
}
